/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsRivlNameScope.h
    
Abstract:

    Incude header files for RIVL namescope related functions

--*/

#ifndef _EMS_RIVL_NAMESCOPE_H_
#define _EMS_RIVL_NAMESCOPE_H_

#include "EmsMain.h"
#include "EmsTypes.h"
#include "EmsTclInit.h"
#include "EmsUtilityString.h"
#include "EmsLogCommand.h"

#define SCOPE_STACK_DEPTH 512
#define MAX_SCOPENAME_LEN 128

typedef struct _RIVL_SCOPE {
  INT8  Name[MAX_SCOPENAME_LEN];  // name
} RIVL_SCOPE;

extern RIVL_SCOPE *RivlScopes[SCOPE_STACK_DEPTH];
extern UINT32     ScopeDepth;

VOID
EmsClearLocalScope(
  VOID
  )
/*++

Routine Description:

  Clear all local scope

Arguments:

  None

Returns:

  None

--*/
;

#endif
