/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsRpcTarget.h
    
Abstract:

    Incude header files for RPC target functions

--*/

#ifndef _EMS_RPC_TARGET_H_
#define _EMS_RPC_TARGET_H_

#include <stdlib.h>
#include <stdio.h>

typedef struct _TARGET_T {
  INT8              Mac[6];
  struct _TARGET_T  *Next;
} TARGET_T;

VOID_P
RpcTargetDumpAll (
  INT8        *Buff
  )
/*++

Routine Description:

  Dump all the targets

Arguments:

  Buff  - The Buffer to contain targets

Returns:

  None

--*/
;

VOID_P
RpcTargetAddByMac (
  INT8      *mac
  )
/*++

Routine Description:

  Add a target identified by MAC address

Arguments:

  Mac - The MAC address

Returns:

  None

--*/
;

TARGET_T  *
RpcTargetFindByMac (
  INT8            *mac
  )
/*++

Routine Description:

  Find the taget by MAC address

Arguments:

  Mac - MAC address

Returns:

  The target found

--*/
;

VOID_P
RpcTargetRemoveAll (
  VOID_P
  )
/*++

Routine Description:

  Remove all the target

Arguments:

  None.

Returns:

  None

--*/
;

#endif
