/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Copyright (c) 2006, Intel Corporation
All rights reserved. 

This UEFI SCT ("Software") is furnished under license and may only be used or copied
in accordance with the terms of that license UEFI Contributor Agreement.
No license, express or implied, by estoppel or otherwise, to any intellectual property
rights is granted by this document. The Software is subject to change without notice,
and should not be construed as a commitment by Intel Corporation to market, license,
sell or support any product or technology. Unless otherwise provided for in the license
under which this Software is provided, the Software is provided AS IS, with no warranties
of any kind, express or implied. Except as expressly permitted by the Software license,
neither Intel Corporation nor its suppliers assumes any responsibility or liability
for any errors or inaccuracies that may appear herein. 

Module Name:

  MiscellaneousBootENTSTestCase.h

Abstract:

--*/

#ifndef _MISCELLANEOUS_BOOT_ENTS_TESTCASE_H_
#define _MISCELLANEOUS_BOOT_ENTS_TESTCASE_H_

#include "Efi.h"
#include "EfiDriverlib.h"
#include "Eas.h"
#include "EntsProtocol.h"
#include "EntsLib.h"

EFI_STATUS
BS_SetWatchdogTimer_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

 SetWatchdogTimer Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
BS_Stall_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

 Stall Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
BS_CopyMem_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

 CopyMem Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
BS_SetMem_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

 SetMem Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

extern CHAR16         *gRuntimeServiceRuntimeInfo;
extern UINTN          gRuntimeServiceRuntimeInfoSize;

extern ENTS_ARG_FIELD gBSSetWatchdogTimerArgField[];
extern ENTS_ARG_FIELD gBSStallArgField[];
extern ENTS_ARG_FIELD gBSCopyMemArgField[];
extern ENTS_ARG_FIELD gBSSetMemArgField[];

#endif
