/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Copyright (c) 2006, Intel Corporation
All rights reserved. 

This UEFI SCT ("Software") is furnished under license and may only be used or copied
in accordance with the terms of that license UEFI Contributor Agreement.
No license, express or implied, by estoppel or otherwise, to any intellectual property
rights is granted by this document. The Software is subject to change without notice,
and should not be construed as a commitment by Intel Corporation to market, license,
sell or support any product or technology. Unless otherwise provided for in the license
under which this Software is provided, the Software is provided AS IS, with no warranties
of any kind, express or implied. Except as expressly permitted by the Software license,
neither Intel Corporation nor its suppliers assumes any responsibility or liability
for any errors or inaccuracies that may appear herein. 

Module Name:

  MiscellaneousRuntimeENTSTestCase.c

Abstract:

--*/

#include "MiscellaneousRuntimeENTSTestCase.h"

//
// RT.ResetSystem
//
static EFI_RESET_TYPE RTResetSystemResetType;
static EFI_STATUS     RTResetSystemResetStatus;
static UINTN          RTResetSystemDataSize;
static CHAR16         *RTResetSystemResetData;

ENTS_ARG_FIELD        gRTResetSystemArgField[] = {
  {
    OCTETN,
    &RTResetSystemResetType
  },
  {
    OCTETN,
    &RTResetSystemResetStatus
  },
  {
    OCTETN,
    &RTResetSystemDataSize
  },
  {
    POINTER,
    &RTResetSystemResetData
  },
  0
};

EFI_STATUS
RT_ResetSystem_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  ResetSystem Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_RUNTIME_SERVICES  *RuntimeService;

  RuntimeService = (EFI_RUNTIME_SERVICES *) ClientInterface;

  RuntimeService->ResetSystem (
                    RTResetSystemResetType,
                    RTResetSystemResetStatus,
                    RTResetSystemDataSize,
                    RTResetSystemResetData
                    );
  return EFI_SUCCESS;
}
