/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  DevicePathProtocol.h

Abstract:

--*/

#ifndef _DEVICE_PATH_FOR_TEST_H_
#define _DEVICE_PATH_FOR_TEST_H_

#include "EfiApi.h"

//
// Device Path protocol
//
#define EFI_DEVICE_PATH_PROTOCOL_GUID \
  { \
    0x9576e91, 0x6d3f, 0x11d2, 0x8e, 0x39, 0x0, 0xa0, 0xc9, 0x69, 0x72, 0x3b \
  }

//#ifndef EFI_END_ENTIRE_DEVICE_PATH
//#define EFI_END_ENTIRE_DEVICE_PATH  0xff
//#endif

#ifndef EFI_END_ENTIRE_DEVICE_PATH_SUBTYPE
#define EFI_END_ENTIRE_DEVICE_PATH_SUBTYPE  0xff
#endif

#ifndef EFI_END_INSTANCE_DEVICE_PATH
#define EFI_END_INSTANCE_DEVICE_PATH  0x01
#endif

#ifndef EFI_END_DEVICE_PATH_LENGTH
#define EFI_END_DEVICE_PATH_LENGTH  (sizeof (EFI_DEVICE_PATH_PROTOCOL))
#endif

#ifndef EfiDevicePathNodeLength
#define EfiDevicePathNodeLength(a)  (((a)->Length[0]) | ((a)->Length[1] << 8))
#endif

#ifndef EfiNextDevicePathNode
#define EfiNextDevicePathNode(a)  ((EFI_DEVICE_PATH_PROTOCOL *) (((UINT8 *) (a)) + EfiDevicePathNodeLength (a)))
#endif

#ifndef EfiDevicePathType
#define EfiDevicePathType(a)  (((a)->Type) & 0x7f)
#endif

#ifndef EfiDevicePathSubType
#define EfiDevicePathSubType(a) ((a)->SubType)
#endif

#ifndef EfiIsDevicePathEndType
#define EfiIsDevicePathEndType(a) (EfiDevicePathType (a) == 0x7f)
#endif

#ifndef EfiIsDevicePathEndSubType
#define EfiIsDevicePathEndSubType(a)  ((a)->SubType == EFI_END_ENTIRE_DEVICE_PATH_SUBTYPE)
#endif

#ifndef EfiIsDevicePathEndInstanceSubType
#define EfiIsDevicePathEndInstanceSubType(a)  ((a)->SubType == EFI_END_INSTANCE_DEVICE_PATH)
#endif

#ifndef EfiIsDevicePathEnd
#define EfiIsDevicePathEnd(a) (EfiIsDevicePathEndType (a) && EfiIsDevicePathEndSubType (a))
#endif

#ifndef EfiIsDevicePathEndInstance
#define EfiIsDevicePathEndInstance(a) (EfiIsDevicePathEndType (a) && EfiIsDevicePathEndInstanceSubType (a))
#endif

extern EFI_GUID gEfiDevicePathProtocolGuid;

#endif /* _DEVICE_PATH_FOR_TEST_H_ */
