/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  SctLoad.h

Abstract:

  This file provides the services to load test files and test support library
  files.

--*/

#ifndef _EFI_SCT_LOAD_H_
#define _EFI_SCT_LOAD_H_

//
// External functions declaration
//

//
// Test support file services
//

EFI_STATUS
LoadSupportFiles (
  IN EFI_DEVICE_PATH_PROTOCOL     *DevicePath,
  IN CHAR16                       *FilePath,
  IN BOOLEAN                      Recursive,
  OUT EFI_LIST_ENTRY              *SupportFileList
  );

EFI_STATUS
UnloadSupportFiles (
  IN EFI_LIST_ENTRY               *SupportFileList
  );

EFI_STATUS
LoadProxyFiles (
  IN EFI_DEVICE_PATH_PROTOCOL     *DevicePath,
  IN CHAR16                       *FilePath,
  IN BOOLEAN                      Recursive,
  OUT EFI_LIST_ENTRY              *SupportFileList
  );

EFI_STATUS
UnloadProxyFiles (
  IN EFI_LIST_ENTRY               *SupportFileList
  );

EFI_STATUS
OpenStandardSupportFiles (
  VOID
  );

EFI_STATUS
CloseStandardSupportFiles (
  VOID
  );

EFI_STATUS
OpenExtendedSupportFiles (
  IN EFI_GUID                     *Guids
  );

EFI_STATUS
CloseExtendedSupportFiles (
  IN EFI_GUID                     *Guids
  );

//
// Test file service
//

EFI_STATUS
LoadTestFiles (
  IN EFI_DEVICE_PATH_PROTOCOL     *DevicePath,
  IN CHAR16                       *FilePath,
  IN BOOLEAN                      Recursive,
  OUT EFI_LIST_ENTRY              *TestFileList
  );

EFI_STATUS
UnloadTestFiles (
  IN EFI_LIST_ENTRY               *TestFileList
  );

EFI_STATUS
FindTestFileByCaseGuid (
  IN EFI_GUID                     *Guid,
  OUT EFI_SCT_TEST_FILE           **TestFile,
  OUT VOID                        **TestProtocol,
  OUT VOID                        **TestEntry
  );

#endif
